<?PHP
  class Installer{
    public $step         = 1;
    public $allsteps     = 5;
    public $steps        = null;
    public $params       = null;
    private $systemcheck = true;
    public $isInstalled  = false;

    public function __construct(){
      $this->addWelcomePage();
      $this->addLicencePage();
      $this->addCheckPage();
      $this->addDbSettings();
      $this->addSettings();
      $this->addFinish();
      $this->allsteps = sizeof($this->steps);
    }
    
    private function addWelcomePage(){
      $step['headline'] = 'Willkommen';
      $step['content']  = '<p>
        Willkommen zur ContentLion Installation!</p>
      <p>
        Sie haben mit ContentLion eine gute Wahl getroffen.<br />
        ContentLion ist ein simples und stabiles CMS, <br />
        was Sie nicht im Stich l&auml;sst!
      </p><p>
        Wenn Sie doch Probleme bei der Installation haben, <br />
        kann Ihnen 
        <a href="http://wiki.contentlion.org/index.php?title=Installation">
          dieser Artikel
        </a>
        weiterhelfen.
      </p>';
      $this->steps[] = $step;
    }
    
    private function addLicencePage(){
      $step['headline'] = 'Lizenz';
      $step['content']  = '
ContentLion f�llt unter den Lizenzvertrag <a href="http://creativecommons.org/licenses/GPL/2.0/">CC-GNU GPL</a> der Version 2.0 oder h�her.<br />
Es gibt grob Beschrieben folgende Einschr&auml;nkungen:
<ul>
  <li>In jeder Vervielf&auml;tigung des Programmes muss ContentLion genannt werden.</li>
  <li>Jede Vervielf&auml;tigung muss unter der gleichen Lizenz angeboten werden</li>
  <li>Bei Weitergabe muss der lesbare Quellcode mit&uuml;bergeben werden</li>
</ul><a href="http://creativecommons.org/licenses/GPL/2.0/">
<img alt="CC-GNU GPL" border="0" src="http://creativecommons.org/images/public/cc-GPL-a.png" /></a><br />
';
      $this->steps[] = $step;
    }
    
    private function addCheckPage(){
      $step['headline'] = 'Systemcheck';
      $step['content']  = "<p>Hier werden die Systemanforderungen von ContentLion gepr&uuml;ft.<br />
                           Wenn etwas rot markiert ist, wird ContentLion auf Ihrem System leider nicht funktionieren.</p>
                           <table>
                             <tr>
                               <td>PHP Version</td>
                               <td class='";
      if(substr(phpversion(),0,1) >= 5){
        $step['content'] .= "right'>Stimmt";
      }
      else{
        $step['content'] .= "wrong'>Stimm nicht";
        $this->systemcheck = false;
      }
      $step['content'] .= "    </td>
                             </tr>
                             <tr>
                               <td>Liegt in (Sub)Domain</td>
                               <td class='";
      if(count(split("/",$_SERVER['REQUEST_URI'])) == 2){
        $step['content'] .= "right'>Stimmt";
      }
      else{
        $step['content'] .= "wrong'>Stimm nicht";
        $this->systemcheck = false;
      }
      $step['content'] .= "    </td>
                             </tr>
                          </table>";
      $this->steps[] = $step;
    }
    
    public function getHeadline(){
      return $this->steps[$this->step-1]['headline'];
    }
    
    public function getContent(){
      $res =  $this->steps[$this->step-1]['content'];
      
      if($this->step == $this->allsteps){
          $this->runInstallation();
      }
      if(isset($this->params[$this->step-1]) && $this->params[$this->step-1]){
        foreach($this->params[$this->step-1] as $name=>$value){
          $res = str_replace("{".$name."}",$value,$res);
        }
      }
      return $res;
    }
    
    private function runInstallation(){
      $this->writeDBSettings();
      include('system/dbsettings.php');
      $connection = mysql_connect($dbhost,$dbuser,$dbpassword);
      mysql_select_db($db,$connection);
      $this->createTables();
      $this->insertRows();
      $this->isInstalled = true;
    }
    
    private function addDbSettings(){
      $step['headline'] = 'Datenbank Einstellungen';
      $step['content']  = '
<table>
  <tr>
    <td>Host:</td>
    <td><input name="host" value="{host}" /></td>
  </tr>
  <tr>
    <td>Datenbank:</td>
    <td><input name="database" value="{database}" /></td>
  </tr>
  <tr>
    <td>Benutzer:</td>
    <td><input name="user" value="{user}" /></td>
  </tr>
  <tr>
    <td>Passwort:</td>
    <td><input name="password" type="password" value="{password}" /></td>
  </tr>
  <tr>
    <td>Tabellen Pr&auml;fix:</td>
    <td><input name="praefix" value="{praefix}" /></td>
  </tr>
</table>';
      $this->params[3]['host']     = 'localhost';
      $this->params[3]['database'] = '';
      $this->params[3]['user']     = '';
      $this->params[3]['password'] = '';
      $this->params[3]['praefix']  = 'cl_';
      $this->steps[] = $step;
    }
    
    private function addFinish(){
      $step['headline'] = 'Fertigstellen';
      $step['content']  = 'ContentLion wurde erfolgreich installiert.<br />
      Sie werden nun zur Login-Seite weitergeleitet.
      Sollte die Weiterleitung nicht funktionieren, klicken Sie <a href="/login.html">hier</a>.';
      $this->steps[] = $step;
    }
    
    public function showBackButton(){
      return $this->step > 1 and $this->step != $this->allsteps;
    }
    
    public function showNextButton(){
      return $this->step < $this->allsteps-1;
    }
    
    public function showFinishButton(){
      return $this->step == $this->allsteps-1;
    }
    
    private function addSettings(){
      $step['headline'] = 'Website Einstellungen';
      $step['content']  = '
<table>
  <tr>
    <td>Name der Website:</td>
    <td><input name="name" value="{name}" /></td>
  </tr>
  <tr>
    <td>Benutzername:</td>
    <td><input name="user" value="{user}" /></td>
  </tr>
  <tr>
    <td>Password:</td>
    <td><input name="password" type="password" value="{password}" /></td>
  </tr>
</table>
';
      $this->params[4]['name']     = '';
      $this->params[4]['user']     = '';
      $this->params[4]['password'] = '';
      $this->steps[] = $step;
    }
      
    public function validateCurrentStep(){
      return $this->step != 3 or $this->systemcheck;
    }
    
    private function writeDBSettings(){
      $handle = fopen ( "system/dbsettings.php", "w" );
      fwrite($handle,'
<?PHP
  $dbpraefix = "'.$this->params[3]['praefix'].'";
  $dbhost = "'.$this->params[3]['host'].'";
  $dbpassword = "'.$this->params[3]['password'].'";
  $dbuser = "'.$this->params[3]['user'].'";
  $db = "'.$this->params[3]['database'].'";
?>');
      fclose($handle );
    }
    
    private function createTables(){
      mysql_query("CREATE TABLE `".$this->params[3]['praefix']."activated_plugins` (
  `path` varchar(100) NOT NULL,
  PRIMARY KEY  (`path`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;");
mysql_query("CREATE TABLE `".$this->params[3]['praefix']."custom_css` (
  `id` varchar(100) NOT NULL,
  `stylePath` varchar(100) NOT NULL,
  PRIMARY KEY  (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;");
mysql_query("CREATE TABLE `".$this->params[3]['praefix']."dashboards` (
  `alias` varchar(255) NOT NULL,
  `col` int(1) NOT NULL,
  `row` int(2) NOT NULL,
  `path` varchar(255) NOT NULL,
  PRIMARY KEY  (`alias`,`col`,`row`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;");
mysql_query("CREATE TABLE `".$this->params[3]['praefix']."events` (
  `event` varchar(50) NOT NULL,
  `file` varchar(50) NOT NULL,
  PRIMARY KEY  (`event`,`file`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;");
mysql_query("CREATE TABLE `".$this->params[3]['praefix']."images` (
  `path` varchar(255) NOT NULL,
  `name` varchar(75) NOT NULL,
  `description` varchar(255) NOT NULL,
  PRIMARY KEY  (`path`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;");
mysql_query("CREATE TABLE `".$this->params[3]['praefix']."menu` (
  `id` int(2) NOT NULL,
  `menuID` int(3) NOT NULL,
  `title` varchar(100) NOT NULL,
  `href` varchar(255) NOT NULL,
  `type` int(1) NOT NULL,
  PRIMARY KEY  (`id`,`menuID`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;");
mysql_query("CREATE TABLE `".$this->params[3]['praefix']."menu_names` (
  `id` int(4) NOT NULL auto_increment,
  `name` varchar(30) NOT NULL,
  PRIMARY KEY  (`id`)
) ENGINE=MyISAM AUTO_INCREMENT=17 DEFAULT CHARSET=utf8 AUTO_INCREMENT=17 ;");
mysql_query("CREATE TABLE `".$this->params[3]['praefix']."meta_global` (
  `name` varchar(100) NOT NULL,
  `content` varchar(100) NOT NULL,
  PRIMARY KEY  (`name`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;");
mysql_query("CREATE TABLE `".$this->params[3]['praefix']."meta_local` (
  `name` varchar(100) NOT NULL,
  `page` int(11) NOT NULL,
  `content` varchar(100) NOT NULL,
  PRIMARY KEY  (`name`,`page`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;");
mysql_query("CREATE TABLE `".$this->params[3]['praefix']."pages` (
  `id` int(8) NOT NULL auto_increment,
  `alias` varchar(255) NOT NULL,
  `title` varchar(255) NOT NULL,
  `owner` int(11) NOT NULL default '-1',
  `menu` int(11) NOT NULL default '-1',
  `editor` varchar(50) NOT NULL default 'WYSIWYG',
  PRIMARY KEY  (`id`)
) ENGINE=MyISAM AUTO_INCREMENT=35 DEFAULT CHARSET=utf8 AUTO_INCREMENT=35 ;");
mysql_query("CREATE TABLE `".$this->params[3]['praefix']."settings` (
  `role` int(10) NOT NULL default '3',
  `area` varchar(20) NOT NULL,
  `areaType` varchar(20) NOT NULL,
  `property` varchar(255) NOT NULL,
  `value` varchar(255) NOT NULL,
  `activated` int(1) NOT NULL default '1',
  `description` varchar(75) NOT NULL,
  `type` varchar(50) NOT NULL,
  PRIMARY KEY  (`role`,`area`,`areaType`,`property`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;");
mysql_query("CREATE TABLE `".$this->params[3]['praefix']."skins` (
  `id` int(3) NOT NULL auto_increment,
  `name` varchar(30) NOT NULL,
  PRIMARY KEY  (`id`)
) ENGINE=MyISAM AUTO_INCREMENT=2 DEFAULT CHARSET=utf8 AUTO_INCREMENT=2 ;");
mysql_query("CREATE TABLE `".$this->params[3]['praefix']."user` (
  `id` int(11) NOT NULL auto_increment,
  `name` varchar(50) NOT NULL,
  `password` varchar(50) NOT NULL,
  `role` int(10) NOT NULL,
  PRIMARY KEY  (`id`,`name`)
) ENGINE=MyISAM AUTO_INCREMENT=2 DEFAULT CHARSET=utf8 AUTO_INCREMENT=2 ;");
mysql_query("CREATE TABLE `".$this->params[3]['praefix']."widgets` (
  `path` varchar(255) NOT NULL,
  `name` varchar(50) NOT NULL,
  `class` varchar(50) NOT NULL,
  PRIMARY KEY  (`path`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;");
mysql_query("CREATE TABLE `".$this->params[3]['praefix']."roles` (
  `id` int(10) NOT NULL auto_increment,
  `name` varchar(50) NOT NULL,
  PRIMARY KEY  (`id`)
) ENGINE=MyISAM AUTO_INCREMENT=4 DEFAULT CHARSET=utf8 AUTO_INCREMENT=4 ;");
mysql_query("CREATE TABLE `".$this->params[3]['praefix']."pagetypes` (
  `id` INT( 10 ) NOT NULL AUTO_INCREMENT ,
  `class` VARCHAR( 50 ) NOT NULL ,
  `name` VARCHAR( 50 ) NOT NULL ,
  PRIMARY KEY ( `id` ) ) TYPE = MYISAM ;");
mysql_query("CREATE TABLE `".$this->params[3]['praefix']."role_rights` (
  `role` int(10) NOT NULL,
  `page` int(10) NOT NULL,
  PRIMARY KEY  (`role`,`page`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;");
}
    
    private function insertRows(){
      mysql_query("INSERT INTO `".$this->params[3]['praefix']."menu_names` VALUES (1, '{admin}');");
      mysql_query("INSERT INTO `".$this->params[3]['praefix']."menu_names` VALUES (2, '{mainmenu}');");
      mysql_query("INSERT INTO `".$this->params[3]['praefix']."menu` VALUES (1, 1, 'Dashboard', '/admin/home.html',1);");
      mysql_query("INSERT INTO `".$this->params[3]['praefix']."menu` VALUES (2, 1, 'Seiten', '/admin/pages.html',1);");
      mysql_query("INSERT INTO `".$this->params[3]['praefix']."menu` VALUES (3, 1, 'Men�s', '/admin/menus.html',1);");
      mysql_query("INSERT INTO `".$this->params[3]['praefix']."menu` VALUES (4, 1, 'Dateien', '/admin/files.html',1);");
      mysql_query("INSERT INTO `".$this->params[3]['praefix']."menu` VALUES (5, 1, 'Plugins', '/admin/plugins.html',1);");
      mysql_query("INSERT INTO `".$this->params[3]['praefix']."menu` VALUES (7, 1, 'Einstellungen', '/admin/settings.html',1);");
      mysql_query("INSERT INTO `".$this->params[3]['praefix']."menu` VALUES (8, 1, 'Benutzer', '/admin/user.html',1);");
      mysql_query("INSERT INTO `".$this->params[3]['praefix']."menu` VALUES (9, 1, 'Logout', '/admin/logout.html',1);");
      mysql_query("INSERT INTO `".$this->params[3]['praefix']."menu` VALUES (10, 2, 'Startseite', '1', 0);");
      mysql_query("INSERT INTO `".$this->params[3]['praefix']."menu` VALUES (11, 2, 'Login', '2', 0);");
      mysql_query("INSERT INTO `".$this->params[3]['praefix']."user` VALUES (1, '".$this->params[4]['user']."', '".md5($this->params[4]['password'])."',2);");
      mysql_query("INSERT INTO `".$this->params[3]['praefix']."settings` VALUES (3,'global', 'global', 'title', '".$this->params[4]['name']."', 1, 'Titel des CMS','textbox');");
      mysql_query("INSERT INTO `".$this->params[3]['praefix']."settings` VALUES (3,'global', 'global', 'selectedskin', '1', 1, 'Aktueller Skin','skinselector');");
      mysql_query("INSERT INTO `".$this->params[3]['praefix']."settings` VALUES (3,'global', 'global', 'selectedmobileskin', '1', 1, 'Mobiler Skin','mobileskinselector');");
      mysql_query("INSERT INTO `".$this->params[3]['praefix']."settings` VALUES (3,'default', 'skins', 'skinbgcolor', 'dedede', 1, 'Hintergrundfarbe','colorpicker');");
      mysql_query("INSERT INTO `".$this->params[3]['praefix']."settings` VALUES (3,'default', 'skins', 'skinforecolor', '525252', 1, 'Schriftfarbe','colorpicker');");
      mysql_query("INSERT INTO `".$this->params[3]['praefix']."settings` VALUES (3,'default', 'skins', 'skinhighlight1', 'ff0000', 1, 'Highlight Farbe 1','colorpicker');");
      mysql_query("INSERT INTO `".$this->params[3]['praefix']."settings` VALUES (3,'default', 'skins', 'skinhighlight2', 'b3fa00', 1, 'Highlight Farbe 2','colorpicker');");
      mysql_query("INSERT INTO `".$this->params[3]['praefix']."settings` VALUES (3,'global', 'global', 'host', 'http://".$_SERVER['HTTP_HOST']."', 1, 'URL der Startseite','textbox');");
      mysql_query("INSERT INTO `".$this->params[3]['praefix']."settings` VALUES (3, 'global', 'global', 'mainmenu', '2', 0, 'Hauptmen�', 'menueselector');");
      mysql_query("INSERT INTO `".$this->params[3]['praefix']."settings` VALUES (3, 'global', 'global', 'accessdenied', '0', 1, 'Zugriff-Verweigert-Seite', 'pageselector');");
      mysql_query("INSERT INTO `".$this->params[3]['praefix']."settings` VALUES (3, 'global', 'global', 'iconset', 'famfamfam', 1, 'Iconset', 'iconsetselector');");
      mysql_query("INSERT INTO `".$this->params[3]['praefix']."settings` VALUES (2, 'global', 'global', 'mainmenu', '1', 1, 'Hauptmen�', 'menueselector');");
      mysql_query("INSERT INTO `".$this->params[3]['praefix']."settings` VALUES (3, 'global', 'global', 'language', 'de', 1, 'Sprache', 'languageselector');");
      mysql_query("INSERT INTO `".$this->params[3]['praefix']."settings` VALUES (3, 'global', 'global', 'root', '".$_SERVER['DOCUMENT_ROOT']."/', 1, 'Root-Path', 'textbox');");
      mysql_query("INSERT INTO `".$this->params[3]['praefix']."settings` VALUES (2,'global', 'global', 'selectedskin', '3', 1, 'Aktueller Skin','skinselector');");
      mysql_query("INSERT INTO `".$this->params[3]['praefix']."skins` VALUES (1, 'default');");
      mysql_query("INSERT INTO `".$this->params[3]['praefix']."skins` VALUES (2, 'mobile');");
      mysql_query("INSERT INTO `".$this->params[3]['praefix']."skins` VALUES (3, 'backenddefault');");
      mysql_query("INSERT INTO `".$this->params[3]['praefix']."roles` VALUES (1, 'Gast');");
      mysql_query("INSERT INTO `".$this->params[3]['praefix']."roles` VALUES (2, 'Administator');");
      mysql_query("INSERT INTO `".$this->params[3]['praefix']."roles` VALUES (3, 'Alle');");
      mysql_query("INSERT INTO `".$this->params[3]['praefix']."pagetypes` VALUES (1, 'wysiwyg', 'Textseite');");
      mysql_query("INSERT INTO `".$this->params[3]['praefix']."pagetypes` VALUES (2, 'login', 'Login');");
      mysql_query("INSERT INTO `".$this->params[3]['praefix']."pagetypes` VALUES (3, 'dashboard', 'Dashboard');");
      mysql_query("INSERT INTO `".$this->params[3]['praefix']."pages` VALUES (1, 'home', 'Startseite', -1, 0, 'wysiwyg');");
      mysql_query("INSERT INTO `".$this->params[3]['praefix']."pages` VALUES (2, 'login', 'Login', -1, 0, 'login');");
      mysql_query("INSERT INTO `".$this->params[3]['praefix']."pages` VALUES (3, 'zugriff-verweigert', 'Zugriff verweigert', -1, 0, 'wysiwyg');");
      mysql_query("INSERT INTO `".$this->params[3]['praefix']."pages` VALUES (4, 'admin/plugins', 'Plugins', -1, 0, 'wysiwyg');");
      mysql_query("INSERT INTO `".$this->params[3]['praefix']."pages` VALUES (5, 'admin/files', 'Dateien', -1, 0, 'wysiwyg');");
      mysql_query("INSERT INTO `".$this->params[3]['praefix']."pages` VALUES (6, 'admin/menus', 'Men�s', -1, 0, 'wysiwyg');");
      mysql_query("INSERT INTO `".$this->params[3]['praefix']."pages` VALUES (7, 'admin/home', 'Dashboard', -1, 0, 'dashboard');");
      mysql_query("INSERT INTO `".$this->params[3]['praefix']."pages` VALUES (8, 'admin/pages', 'Seiten', -1, 0, 'wysiwyg');");
      mysql_query("INSERT INTO `".$this->params[3]['praefix']."pages` VALUES (9, 'admin/settings', 'Einstellungen', -1, 0, 'wysiwyg');");
      mysql_query("INSERT INTO `".$this->params[3]['praefix']."pages` VALUES (9, 'admin/settings', 'Einstellungen', -1, 0, 'wysiwyg');");
      mysql_query("INSERT INTO `".$this->params[3]['praefix']."pages` VALUES (10, 'admin/logout', 'Logout', -1, 0, 'wysiwyg');");
      mysql_query("INSERT INTO `".$this->params[3]['praefix']."pages` VALUES (11, 'admin/user', 'Benutzer', -1, 0, 'wysiwyg');");
      mysql_query("INSERT INTO `".$this->params[3]['praefix']."dashboards` VALUES ('admin/home', 2, 1, 'lookaround/widget.php');");
      mysql_query("INSERT INTO `".$this->params[3]['praefix']."dashboards` VALUES ('admin/home', 1, 1, 'pagelistwidget/pagelistwidget.php');");
      mysql_query("INSERT INTO `".$this->params[3]['praefix']."dashboards` VALUES ('admin/home', 3, 1, 'filelistwidget/filelistwidget.php');");
      mysql_query("INSERT INTO `".$this->params[3]['praefix']."widgets` VALUES ('lookaround/widget.php', 'LookAround', 'LookAround');");
      mysql_query("INSERT INTO `".$this->params[3]['praefix']."widgets` VALUES ('pagelistwidget/pagelistwidget.php', 'PageList', 'PageListWidget');");
      mysql_query("INSERT INTO `".$this->params[3]['praefix']."widgets` VALUES ('filelistwidget/filelistwidget.php', 'FileList', 'FileListWidget');");
      mysql_query("INSERT INTO `".$this->params[3]['praefix']."role_rights` VALUES (1,1);");
      mysql_query("INSERT INTO `".$this->params[3]['praefix']."role_rights` VALUES (1,2);");
      mysql_query("INSERT INTO `".$this->params[3]['praefix']."role_rights` VALUES (1,3);");
      mysql_query("INSERT INTO `".$this->params[3]['praefix']."role_rights` VALUES (2,1);");
      mysql_query("INSERT INTO `".$this->params[3]['praefix']."role_rights` VALUES (2,2);");
      mysql_query("INSERT INTO `".$this->params[3]['praefix']."role_rights` VALUES (2,3);");
      mysql_query("INSERT INTO `".$this->params[3]['praefix']."role_rights` VALUES (3,1);");
      mysql_query("INSERT INTO `".$this->params[3]['praefix']."role_rights` VALUES (3,2);");
      mysql_query("INSERT INTO `".$this->params[3]['praefix']."role_rights` VALUES (3,3);");
      mysql_query("INSERT INTO `".$this->params[3]['praefix']."role_rights` VALUES (2,4);");
      mysql_query("INSERT INTO `".$this->params[3]['praefix']."role_rights` VALUES (2,5);");
      mysql_query("INSERT INTO `".$this->params[3]['praefix']."role_rights` VALUES (2,6);");
      mysql_query("INSERT INTO `".$this->params[3]['praefix']."role_rights` VALUES (2,7);");
      mysql_query("INSERT INTO `".$this->params[3]['praefix']."role_rights` VALUES (2,8);");
      mysql_query("INSERT INTO `".$this->params[3]['praefix']."role_rights` VALUES (2,9);");
      mysql_query("INSERT INTO `".$this->params[3]['praefix']."role_rights` VALUES (2,10);");
      mysql_query("INSERT INTO `".$this->params[3]['praefix']."role_rights` VALUES (2,11);");
      mysql_query("INSERT INTO `".$this->params[3]['praefix']."activated_plugins` VALUES ('lookaround');");
      mysql_query("INSERT INTO `".$this->params[3]['praefix']."activated_plugins` VALUES ('pagelistwidget');");
      mysql_query("INSERT INTO `".$this->params[3]['praefix']."activated_plugins` VALUES ('filelistwidget');");
    }
    
    public function destroy(){
      unlink('installer/installer.php');
      unlink('installer/logo.jpg');
      rmdir('installer');
      unlink('install.php');
      $_SESSION['installer'] = null;
      unset($this);
    }
  }
?>