<?PHP
  class Dashboard extends Editor{
    public $cols;
    public $usedwidgets = null;

    function getHeader(){
      return "<link href=\"/admin/style.css\" rel=\"stylesheet\" type=\"text/css\" />
              <link href=\"/admin/inettuts.css\" rel=\"stylesheet\" type=\"text/css\" />";
    }
    
    function __construct($page){
      $this->page = $page;
      $this->loadAllWidgets();
    }

    private function loadAllWidgets(){
      $this->cols = null;
      $this->cols[] = $this->loadWidgetsByColumn(0);
      $this->cols[] = $this->loadWidgetsByColumn(1);
      $this->cols[] = $this->loadWidgetsByColumn(2);
      $this->cols[] = $this->loadWidgetsByColumn(3);  
    }
    
    function loadWidgetsByColumn($columnId){
      $res = null;
      $columnId = $GLOBALS['db']->EscapeString($columnId);
      $alias = $GLOBALS['db']->EscapeString($this->page->alias);
      $rows = $GLOBALS['db']->ReadRows("SELECT path FROM {'dbprefix'}dashboards 
                                        WHERE col = '".$columnId."' AND alias = '".$alias."'
                                           ORDER BY row");
      if($rows){
        foreach($rows as $row){
          $widgetData = WidgetController::getWidgetData($row->path);
          $widget = WidgetController::getWidget($widgetData);
          $widget->load();
          $res[] = $widget;
        }
      }
      
      return $res;
    }
    
    function display(){
      echo "<div id=\"columns\">";
      $this->displayColumn(1);
      $this->displayColumn(2);
      $this->displayColumn(3);
      ?>
        <script type="text/javascript" src="http://jqueryjs.googlecode.com/files/jquery-1.2.6.min.js"></script>
        <script type="text/javascript" src="/admin/jquery-ui-personalized-1.6rc2.min.js"></script>
        <script type="text/javascript" src="/admin/inettuts.js"></script>
      <?PHP
      echo "</div>";
    }
    
    public function getEditableCode(){
      $template = new Template();
      $template->load("control_dashboardedit");
      $template->assign_var("URL",$_SERVER['PHP_SELF']."?".$_SERVER['QUERY_STRING']);
      if($_POST['save']){
        $this->delete();
        $allwidgets = WidgetController::getAllWidgets();
        foreach($allwidgets as $widget){
          if(isset($_POST[str_replace(".","_",$widget->path)])){
            $widget->load();
            $parts = split("\|",$_POST[str_replace(".","_",$widget->path)]);
            if($parts[0] == "HIDDENWIDGETS"){
              $widget->save($this->page->alias,0,$parts[1]);
            }
            else if($parts[0] == "COLUMN1WIDGETS"){
              $widget->save($this->page->alias,1,$parts[1]);
            }
            else if($parts[0] == "COLUMN2WIDGETS"){
              $widget->save($this->page->alias,2,$parts[1]);
            }
            else if($parts[0] == "COLUMN3WIDGETS"){
              $widget->save($this->page->alias,3,$parts[1]);
            }
          }
        }
        $this->loadAllWidgets();
      }
      foreach($allwidgets as $widget){
        $widget->load();
      }
      $i = 0;
      $pos = 0;
      foreach($this->cols as $col){
        if($col && $i != 0){
          foreach($col as $widget){
            $index = $template->add_loop_item("COLUMN".$i."WIDGETS");
            $this->addWidgetToEditable($template,"COLUMN".$i."WIDGETS",$widget,$index,$pos);
            $pos++;
          }
        }
        $i++;
      }
      $hiddenwidgets = $this->getHiddenWidgets();
      $i = 0;
      if($hiddenwidgets){
        foreach($hiddenwidgets as $widget){
            $index = $template->add_loop_item("HIDDENWIDGETS");
            $this->addWidgetToEditable($template,"HIDDENWIDGETS",$widget,$index,$i);
            $i++;
        }
      }
      $i = 0;
      if($allwidgets){
        foreach($allwidgets as $widget){
          $addItem = !$this->usedwidgets;
          if(!$addItem) $addItem = !in_array($widget->path,$this->usedwidgets);
          if($addItem){
            $widget->load();
            $index = $template->add_loop_item("DONTUSEDWIDGETS");
            $this->addWidgetToEditable($template,"DONTUSEDWIDGETS",$widget,$index,$i);
            $i++;
          }
        }
      }
      return $template->getCode();
    }

    private function addWidgetToEditable($template,$column,$widget,$index,$position){
      $template->assign_loop_var($column,$index,"WIDGETNAME",htmlentities($widget->headline));
      $template->assign_loop_var($column,$index,"WIDGETPATH",htmlentities(str_replace(".","_",$widget->path)));
      $template->assign_loop_var($column,$index,"PLACE",$column."|".$position);
      $this->usedwidgets[] = $widget->path;
      return $template;
    }
    
    public function save($newPage,$oldPage){
    }
    
    function displayColumn($id){
      ?>
        <ul id="column<?PHP echo $id - 1; ?>" class="column">
          <?PHP
            if($this->cols[$id]){
              foreach($this->cols[$id] as $widget){
                $widget->displayType = "dashboard";
                $widget->display();
              }
            }
          ?>
        </ul>
      <?PHP
    }

    function getHiddenWidgets(){
      $widgets = $GLOBALS['db']->ReadRows("SELECT class,{'dbprefix'}dashboards.path FROM {'dbprefix'}dashboards INNER JOIN {'dbprefix'}widgets ON {'dbprefix'}dashboards.path = {'dbprefix'}widgets.path WHERE alias = '".$GLOBALS['db']->EscapeString($this->page->alias)."' AND col = '0'");
      if($widgets){
        foreach($widgets as $widget){
          $widget = WidgetController::getWidget($widget);
          $widget->load();
          $res[] = $widget;
        }
      }
      return $res;
    }

    public function delete(){
      $dashboard = $GLOBALS['db']->EscapeString($this->page->alias);
      $GLOBALS['db']->Execute("DELETE FROM {'dbprefix'}dashboards WHERE alias = '".$dashboard."'");
    }
  }
?>